Program HashTablaFeltolteshezAdatGeneralas;
  Uses Newdelay,Crt;
  (*
    A tabla elem tipusa=Nev+Cim+Tel.szam
    TElem=Record
            nev:TNev{String[M=40]};
            cim:TNev{String[M]};
            tel:TNev{String[M]};
           End;
    E 3 adat szerepel majd (az elso sor utan, amely az elemek szama),
    a generalt TEXT-ben, soronkent 1 adattal.
    (Azaz 1 elem adatai 3 sorban.)

    A kereso file-ban csak kulcsok (nevek) szerepelnek.
    Itt is az elso sor a kulcsok szama.
    A file elejen garantaltan olyanok, amelyek az alap adatok kozt is
    elofordulnak.
  *)

  {$i RandNev.inc -- Veletlen Nev, Cim, Telefonszam generalo rutinok}
  {$i AltRutin.inc -- mindenfele altalanos rutin}

  Const tollSzin=Black;
        papirSzin=White;
        Blink=128;
  Var   N,L:LongInt;    {adat-, lekrdez file mrete}
        af,lf:Text;     {adat-, lekrdez file}
        afN,lfN:String; {adat-, lekrdez file neve}
        VanIsm:Boolean;

  Procedure FileMegnyitas(Var fN:String; Var f:Text);
    Var  hiba:Integer;
  Begin
    Repeat
      Write('Adat file neve (*.dat):');
      Readln(fN);
      {$i-}
      Assign(f,fN+'.dat'); Reset(f);
      hiba:=IOResult;
      If hiba<>0 then
      Begin
        Rewrite(f);
        hiba:=IOResult;
        If hiba<>0 then
        Begin
          TextColor(Red+Blink);
          Writeln('A file nem nyithat meg:');
          Writeln('  Hibs file-nv.');
          TextColor(tollSzin);
        End
      End
        Else
      Begin
        hiba:=-1;
        TextColor(Red+Blink);
        Writeln('A file nem nyithat meg:');
        Writeln('  Ilyen file mr van.');
        TextColor(tollSzin);
      End;
      {$i+}
    Until hiba=0;
  End;

  Procedure AlapParameterBeolvasas;
  Begin
    UjLap('Tbla-input-generls -- Alap-paramterek',0);
    FileMegnyitas(aFn,aF);
    Repeat
      Write('Elemszm:');
      {$i-}
      Readln(N)
      {$i+}
    Until N>0;
  End;

  Procedure AlapTablaFileGeneralas;
    Var i:LongInt;
        nev,cim,tel:TNev;
        c:Char;
  Begin
    UjLap('Tbla-input-generls -- Alapadatok generlsa',0);
    AlapParameterBeolvasas;
    Write('"Teljesen" vletlen adatgenerls? (I/.) '); c:=ReadKey;
    If UpCase(c)='I' then Randomize;
    Writeln(aF,N); Writeln(N:9);
    For i:=1 to N do
    Begin
      HighVideo; Write(i:5); NormVideo;
      nev:=RandomNev; Writeln(aF,nev); Write(nev:25,'');
      cim:=RandomCim; Writeln(aF,cim); Write(cim:37,'');
      tel:=RandomTel; Writeln(aF,tel); Writeln(tel:10);
    End;
    Close(aF);
  End;

  Procedure LekerdezesParameterBeolvasas;
  Begin
    UjLap('Tbla-input-generls -- Keres-paramterek',0);
    FileMegnyitas(lFn,lF);
    Repeat
      Write('Lekrdezs-szm:');
      {$i-}
      Readln(L)
      {$i+}
    Until L>0;
  End;

  Procedure LekerdezesFileGeneralas;
    Var i,j,jN:LongInt;
        nev,mindegy:TNev;
  Begin
    UjLap('Tbla-input-generls -- Lekrdezsek generlsa',0);
    LekerdezesParameterBeolvasas;
    Writeln(lF,L); Writeln(L:9);
    Reset(aF); Readln(aF,mindegy{=N atlepese});
    For i:=1 to L do
    Begin
      HighVideo; Write(i:6); NormVideo;
      If not Eof(af) then {amig lehet az alap adatfile-bol}
      Begin
        Readln(aF,nev); Readln(aF,mindegy); Readln(aF,mindegy);
        {Veletlenszamu elem atlepese az alap adatfile-ban:}
        j:=1; jN:=Random(N Div 10)+1; {az alap adatok 10%-a kerlhet t,
                                       L<N Div 10 esetben esetleg csak
                                       alap adat}
        While not Eof(af) and (j<=jN) do
        Begin
          Readln(aF,mindegy); Readln(aF,mindegy); Readln(aF,mindegy);
          Inc(jN)
        End;
      End
        Else
      Begin
        nev:=RandomNev;
      End;
      Writeln(lF,nev); Write(nev:33,'');
    End;
    Close(lF); Close(aF);
  End;

  Function KulcsIsmetlodes:Boolean;
    Const mFN='_munka_.dat'; {munka direkt-file neve}
          Torolt:TNev='';    {a mar elofordult nevek "allapota"}
    Var   ism:Boolean;
          db,i,j:LongInt;
          nev2,nev,cim,tel:TNev;
          mF:File of TNev;   {munka direkt-file}
  Begin
    UjLap('Tbla-input-generls -- Van-e kulcsismtlds',0);
    ism:=False; i:=0;
    Reset(aF); Readln(aF,nev2{=N atlepese});
    Assign(mF,mfN); Rewrite(mF);
    While Not Eof(aF) do
    Begin
      Readln(aF,nev); Readln(aF,cim); Readln(aF,tel);
      Write(mF,nev);
    End;
    Close(aF);
    For i:=0 to FileSize(mF)-1 do
    Begin
      Seek(mF,i); Read(mF,nev);
      If nev<>Torolt then
      Begin
        Write(nev:40,': ');
        db:=1;
        For j:=i+1 to FileSize(mF)-1 do
        Begin
          Seek(mF,j); Read(mF,nev2);
          If nev2=nev then
          Begin
            Inc(db); Seek(mF,j); Write(mF,Torolt);
          End;
        End;
        Writeln(db);
        ism:=ism or (db>1);
      End;
    End;
    Erase(mF);
    KulcsIsmetlodes:=ism;
  End;

  Procedure Egyesites;
    Var c:Char;
        barmi,
        eFN:String; {egyesitett file neve}
        eF:Text;    {egyesitett file}
  Begin
    Repeat
      Write(CrLf,
            'Egyestsk a file-okat? (I/N):');
      c:=ReadKey; c:=UpCase(c);
    Until c in ['I','N'];
    Writeln;
    If c='I' then
    Begin
      FileMegnyitas(eFN,eF);
      Assign(aF,aFN+'.dat'); Reset(aF);
      While Not Eof(aF) do
      Begin
        Readln(aF,barmi); Writeln(eF,barmi);
      End;
      Close(aF);
      Assign(lF,lFN+'.dat'); Reset(lF);
      While Not Eof(lF) do
      Begin
        Readln(lF,barmi); Writeln(eF,barmi);
      End;
      Close(lF);
      Close(eF);
    End;
  End;

Begin
  TextColor(tollSzin); TextBackground(papirSzin);
  UjLap('Tbla-input-generls',0);
  Writeln(CrLf,
          ' 1. Tbla-alapadatok generlsa: 1. file (teljes elem),');
  Writeln(' 2. Tbla lekrdez adatok generlsa: 2. file (csak kulcs).');
  Writeln(' 3. A kt fenti file eggy egyestse: Tbla-adatok + Kulcs-adatok.');
  Writeln(CrLf,'Tudnivalk a generlt file-okrl:',CrLf);
  Writeln('  Az alap adatok file-ja Nv+Cm+Tel.szm (TElem) adathrmasokbl ll.');
  Writeln('  E 3 adat szerepel majd a generalt TEXT-ben, soronkent 1 adattal.');
  Writeln('  (Azaz 1 elem adatai 3 sorban,');
  Writeln('   kivve az els sort, amely az elemek szma.)');
  Writeln(CrLf,'  A kereso file-ban csak kulcsok (nevek) szerepelnek.');
  Writeln('  A file elejen garantaltan olyanok, amelyek az alap adatok');
  Writeln('  kzt is elofordulnak.');
  Writeln('  (Azaz 1 keres kulcs 1 sorban;');
  Writeln('   kivve az els sort, amely a kulcsok szma.)');
  UjLap('',-1);
  AlapTablaFileGeneralas;
  BillreVar;

  VanIsm:=KulcsIsmetlodes;
  Writeln('Van-e kulcsismtlds a file-ban?: ',VanIsm);
  BillreVar;

  LekerdezesFileGeneralas;
  BillreVar;

  Egyesites;
End.